package com.zt.plat.module.qms.business.config.service;

import java.util.*;

import com.zt.plat.module.qms.business.config.controller.vo.ConfigWarehouseLocationPageReqVO;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigWarehouseLocationRespVO;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigWarehouseLocationSaveReqVO;
import jakarta.validation.*;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigWarehouseLocationDO;
import com.zt.plat.framework.common.pojo.PageResult;

/**
 * 存放位置 Service 接口
 *
 * @author 后台管理
 */
public interface ConfigWarehouseLocationService {

    ConfigWarehouseLocationDO getLocationByCode(String code, String warehouseType);
    ConfigWarehouseLocationDO getByCode(String code);

    void checkCodeUnique(ConfigWarehouseLocationSaveReqVO reqVo);
    void checkCodeUniqueWithoutId(ConfigWarehouseLocationSaveReqVO reqVo);

    //保存数据
    ConfigWarehouseLocationRespVO save(@Valid ConfigWarehouseLocationSaveReqVO reqVO);

    /**
     * 创建存放位置
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    ConfigWarehouseLocationRespVO createConfigWarehouseLocation(@Valid ConfigWarehouseLocationSaveReqVO createReqVO);

    /**
     * 更新存放位置
     *
     * @param updateReqVO 更新信息
     */
    void updateConfigWarehouseLocation(@Valid ConfigWarehouseLocationSaveReqVO updateReqVO);

    /**
     * 删除存放位置
     *
     * @param id 编号
     */
    void deleteConfigWarehouseLocation(Long id);

    /**
    * 批量删除存放位置
    *
    * @param ids 编号
    */
    void deleteConfigWarehouseLocationListByIds(List<Long> ids);

    /**
     * 获得存放位置
     *
     * @param id 编号
     * @return 存放位置
     */
    ConfigWarehouseLocationDO getConfigWarehouseLocation(Long id);

    /**
     * 获得存放位置分页
     *
     * @param pageReqVO 分页查询
     * @return 存放位置分页
     */
    PageResult<ConfigWarehouseLocationRespVO> getConfigWarehouseLocationPage(ConfigWarehouseLocationPageReqVO pageReqVO);

    List<ConfigWarehouseLocationDO> selectListWithPermission(ConfigWarehouseLocationPageReqVO pageReqVO);

    /**
     * 获得存放位置列表
     *
     * @param ids id集合
     * @return 存放位置列表
     */
    List<ConfigWarehouseLocationDO> getListByIds(List<Long> ids);

    /**
     * 获得存放位置列表
     *
     * @param warehouseIds 仓库id集合
     * @return 存放位置列表
     */
    List<ConfigWarehouseLocationDO> getLocationsByWarehouseIds(List<Long> warehouseIds);
}